var template_loadvssoldreport = function (static)
{
	this.static = static;
	this.elements = {
		year: new App.TemplateElement.FieldComponent('year'),
		region: new App.TemplateElement.FieldComponent('region'),
		group: new App.TemplateElement.FieldComponent('group'),
		groupDivision: new App.TemplateElement.FieldComponent('groupDivision'),
		regionalManager: new App.TemplateElement.FieldComponent('regionalManager'),
		company: new App.TemplateElement.FieldComponent('company')
	};
	this.ti = null;
	this.init = function (ti)
	{
		this.ti = ti;
		App.DataStore.loadSelectListData('regions', true, 'Location', 'Region.SelectList');
		//App.DataStore.loadSelectListData('groups', true, 'Company', 'Group.SelectList');
		//App.DataStore.loadSelectListData('regionalManagers', true, 'AppConfig', 'RegionalManager.SelectList');
		App.API.getTask(
			'reportLoadVsSold', 'Report', 'Report.LoadVsSold',
			null, {}, function () {}, _w.taskContractError
		);

		var startYear = 2012;
		var years = [];
		var d = new Date();
		var currentYear = d.getFullYear();
		for (i = startYear; i <= currentYear; i++)
		{
			years.push({'value': i, 'label': i});
		}

		App.DataStore.setData('yearsData', years);

		this.ti.hydrate({
			'year': {
				type: 'select',
				id: 'year',
				title: 'Year',
				value: '',
				dataStoreId: 'yearsData',
			},
			'region': {
				type: 'select',
				id: 'region',
				title: 'Region',
				value: '',
				dataStoreId: 'regions',
				onChange: function () {
					if (!App.DataStore.getItem('BuildSelect:region', false))
					{
						var regionId = $('#region').val();
						$('#group').val('');
						$('#regionalManager').val('');
						$('#groupDivision').val('');
						$('#company').val('');
						App.DataStore.setData('regionalManagers', []);
						App.DataStore.setData('groupdivisions', []);
						App.DataStore.setData('companies', []);
						App.DataStore.loadSelectListData(
								'groups', false, 'Company', 'Group.JoinedSelectList',
								null, {Filter: {
									'region': regionId
									}}
						);
					}
				}
			},
			'group': {
				type: 'select',
				id: 'group',
				title: 'Group Member',
				value: '',
				dataStoreId: 'groups',
				onChange: function () {
					if (!App.DataStore.getItem('BuildSelect:group', false))
					{
						var regionId = $('#region').val();
						var groupId = $('#group').val();
						$('#regionalManager').val('');
						$('#groupDivision').val('');
						$('#company').val('');
						App.DataStore.setData('groupdivisions', []);
						App.DataStore.setData('companies', []);
						App.DataStore.loadSelectListData(
								'regionalManagers', false, 'AppConfig', 'RegionalManager.JoinedSelectList',
								null, {Filter: {
									'region': regionId,
									'group': groupId
									}}
						);
					}
				}
			},
			'regionalManager': {
				type: 'select',
				id: 'regionalManager',
				title: 'Regional Manager',
				value: '',
				dataStoreId: 'regionalManagers',
				multiple: true,
				onChange: function () {
					if (!App.DataStore.getItem('BuildSelect:regionalManager', false))
					{
						var regionId = $('#region').val();
						var groupId = $('#group').val();
						var regionalManagerId = $('#regionalManager').val();
						$('#groupDivision').val('');
						$('#company').val('');
						App.DataStore.setData('companies', []);
						App.DataStore.loadSelectListData(
								'groupdivisions', false, 'Company', 'GroupDivision.JoinedSelectList',
								null, {Filter: {
									region: regionId,
									group: groupId,
									regionalManager: regionalManagerId
									}}
						);
					}
				}
			},
			'groupDivision': {
				type: 'select',
				id: 'groupDivision',
				title: 'Group Division',
				value: '',
				dataStoreId: 'groupdivisions',
				onChange: function () {
					if (!App.DataStore.getItem('BuildSelect:groupDivision', false))
					{
						var regionId = $('#region').val();
						var regionalManagerId = $('#regionalManager').val();
						var groupDivisionId = $('#groupDivision').val();
						$('#company').val('');
						App.DataStore.loadSelectListData(
								'companies', false, 'Company', 'Company.SelectList',
								null, {Filter: {
									region: regionId,
									regionalManager: regionalManagerId,
									groupDivision: groupDivisionId
									}}
						);
					}
				}
			},
			'company': {
				type: 'select',
				id: 'company',
				title: 'Company',
				value: '',
				dataStoreId: 'companies'
			}
		});
	};
	this.construct = function ()
	{
		App.DataStore.setData('groups', []);
		App.DataStore.setData('regionalManagers', []);
		App.DataStore.setData('groupdivisions', []);
		App.DataStore.setData('companies', []);
		$('#frmLoadVsSoldReport').validate({
			rules: {
				year: {required: true},
			},
			messages: {
				year: {
					dateISO: "Year is a required field."
				}
			},
			submitHandler: function (form) {
				var data = {Report: _t['loadvssoldreport'].harvest()};
				App.API.execTask(
								'reportLoadVsSold', data, {},
								function () {
								}, _w.taskExecError,
								'EXPORT', true
								);
			}
		});
		$('#btnReport').prop('disabled', false);
	};
	this.destruct = function () {};
};