var template_pgreport = function( static )
{
	this.static   = static;
	this.elements = {
			dateFrom : new App.TemplateElement.FieldComponent('dateFrom'),
			dateTo : new App.TemplateElement.FieldComponent('dateTo'),
			group : new App.TemplateElement.FieldComponent('group'),
			groupDivision : new App.TemplateElement.FieldComponent('groupDivision'),
			company : new App.TemplateElement.FieldComponent('company')
		};
	this.ti = null;
	this.init = function( ti ) {
		this.ti = ti;
		App.DataStore.loadSelectListData('groups', true, 'Company', 'Group.SelectList');
		App.API.getTask(
				'reportPriceGuide', 'Report', 'Report.PriceGuide',
				null, {}, function(){}, _w.taskContractError
			);
		this.ti.hydrate({
			'dateFrom' : {
				type  : 'date',
				id    : 'dateFrom',
				title : 'Date from',
				style : 'datepicker',
				value : ''
			},
			'dateTo' : {
				type  : 'date',
				id    : 'dateTp',
				title : 'Date to',
				style : 'datepicker',
				value : ''
			},
			'group' : {
				type  : 'select',
				id    : 'group',
				title : 'Group Member',
				value : '',
				dataStoreId : 'groups',
				onChange    : function () {
					if (!App.DataStore.getItem('BuildSelect:group', false))
					{
						var groupId = $('#group').val();
						$('#groupDivision').val('');
						$('#company').val('');
						App.DataStore.loadSelectListData(
								'groupdivisions', false, 'Company', 'GroupDivision.SelectList',
								null, {Filter: {group: groupId}}
								);
						App.DataStore.loadSelectListData(
								'companies', false, 'Company', 'Company.SelectList',
								null, {Filter: {group: groupId}}
								);
					}
				}
			},
			'groupDivision' : {
				type  : 'select',
				id    : 'groupDivision',
				title : 'Group Division',
				value : '',
				dataStoreId : 'groupdivisions',
				onChange    : function () {
					if (!App.DataStore.getItem('BuildSelect:groupDivision', false))
					{
						var groupDivisionId = $('#groupDivision').val();
						$('#company').val('');
						App.DataStore.loadSelectListData(
								'companies', false, 'Company', 'Company.SelectList',
								null, {Filter: {groupDivision: groupDivisionId}}
								);
					}
				}
			},
			'company' : {
				type  : 'select',
				id    : 'company',
				title : 'Company',
				value : '',
				dataStoreId : 'companies'
			}
		});
	};
	this.construct = function() {
		$('#frmPriceGuideReport').validate({
			rules: {
				dateFrom: {required: false, dateISO: true},
				dateTo: {required: false, dateISO: true}
			},
			messages: {
				dateFrom: {
					dateISO: "Must be a valid date."
				},
				dateTo: {
					dateISO: "Must be a valid date."
				}
			},
			submitHandler: function( form ) {
				var data = {Report: _t['pgreport'].harvest()};
				App.API.execTask(
						'reportPriceGuide', data, {},
						function () {}, _w.taskExecError,
						'EXPORT', true
				);
			}
		});
		$('#btnReport').prop('disabled', false);
	};
	this.destruct = function() {};
};