var template_stockbulkimporter = function (static)
{
    this.static = static;
    this.elements = {
        csvFile: new App.TemplateElement.FieldComponent('csvFile'),
        importType: new App.TemplateElement.FieldComponent('importType')
    };
    this.ti = null;
    this.init = function (ti) {
        this.ti = ti;
        App.DataStore.loadSelectListData('groups', true, 'Company', 'Group.SelectList');
        App.API.getTask(
            'StockBulkImporter', 'Stock', 'BulkImport.Upload',
            null, {}, function () {}, _w.taskContractError
        );

        var importTypeData = [];
        if(App.permissions.stockBulkImportDrive)
        {
            importTypeData.push({"value": "Drive", "label": "Drive"});
        }
        if(App.permissions.stockBulkImportPinnacle)
        {
            importTypeData.push({"value": "Pinnacle", "label": "Pinnacle"});
        }

        App.DataStore.setData('importType', importTypeData);

        this.ti.hydrate({
            'csvFile': {
                type: 'document_button',
                id: 'csvFile',
                title: 'TransUnion CSV file'
            },
            'importType': {
                type: 'select',
                id: 'importType',
                title: 'Import Type',
                dataStoreId: 'importType'
            }
        });

    };
    this.construct = function () {

        $('#frmStockBulkUpload').validate({
            rules: {
                csvFile: {required: true},
                importType: {required: true}
            },
            messages: {
                csvFile: {
                    required: "CSV file required."
                },
                importType: {
                    required: "This field required."
                }
            },
            submitHandler: function (form) {
                var data = {Upload: _t['stockbulkimporter'].harvest()};

                if ('' == data.Upload.csvFile)
                {
                    alert('Please select a file to import.');
                    return false;
                }

                App.API.execTask(
                    'StockBulkImporter', data, {},
                    function (response)
                    {
                        alert('Import Running in background!\n\nYou will be notified via email when the import is complete.\n\nPlease note that this page will return to stock grid when you click "OK."');
                        //window.location.reload(false);
                        window.location.hash = '/stock';
                    },
                    function (response)
                    {
                        alert(response.StatusReason);
                    }
                );
            }
        });
        $('#btnSubmitFile').prop('disabled', false);
    };
    this.destruct = function () {};
};